

#############################################################################
# Copyright (C) Labomedia May 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franproplin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################
#
## get_osc.py
#
#  Get OSC data, decode, save in gl
#
#############################################################################

import GameLogic as gl
import socket
from OSC3.OSC import decodeOSC

# init global var
ip = "127.0.0.1"
port = gl.port_in
buffer_size = 1024
# default data
data = []

# Connect Blender
if not gl.connected :
    # if socket exist and not close
    try:
        gl.sock.close()
    except:
        pass

    gl.sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    try:
        gl.sock.bind((ip, port)) # pb with ip !
        gl.sock.setblocking(0)
        gl.sock.settimeout(0.005)
        gl.sock.setsockopt(socket.SOL_SOCKET, socket.SO_RCVBUF, buffer_size)
        print('Get OSC on IP={} Port={} Buffer={}'.format(ip, port, buffer_size))
        gl.connected = True
    except:
        print('No connected to IP={} Port={}'.format(ip, port))
        pass

# If Blender connected
if gl.connected :
    try:
        raw_data = gl.sock.recv(buffer_size)
        #print(raw_data)
        data = decodeOSC(raw_data)
        #print(data)
    except socket.error:
        print("Socket Error: no data, no players_data")
        pass

gl.data = data

if '/quit' in data :
    gl.sock.close()

if '/new_game' in data :
    # Get scenes
    scenes = gl.getSceneList()
    print('New Game')

    # Delete all players scenes
    for n in range(1, 11):
        for scn in scenes :
            if scn.name == str(n) + "_players" :
                scn.end()
    # Start new level 1
    gl.addScene("1_players")

### Global tempo, reset every 2 seconds, used in game.py,
gl.tp += 1
if gl.tp > 120:
    gl.tp = 0
    gl.name = {}





