

#############################################################################
# Copyright (C) Labomedia May 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franproplin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################
#
## players_data.py
#
# This script run every frame and set:
#    gl.players_data     : list of list of all players datas
#    gl.level            : level is also the players number and the scene
#    gl.level_change     : use to set the good scene
#    gl.where            : my position in players_data list with my ip
#
#############################################################################



import GameLogic as gl

goal = gl.goal

def main():
    data = gl.data
    # data example
    # ['/for_all_players', ',ssffsffsi', '192.168.1.4', '/ball', 7.0, 6.1, '/bat', -9.5, 0.0,
    #                                           '/score', 10, '/name', 'qdffsdc', '/rank', 1]
    players_data = []
    # players_data example
    # [['192.168.1.5', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'qdffsdc', '/rank', 1], ['192.168.1.2', '/ball', ...
    #      0               1    2  3     4     5  6     7       8     9         10        11    12

    # Get the good message
    if '/for_all_players' in data and len(data) >= 2:

        ## Simul players to debug
        if gl.debug == 1:
            # max = 8, min = 0
            add = gl.getosc["add"]
            if add > 9 : add = 9
            if add < 0 : add = 0
            for n in range(add):
                for val in range(13):
                    # Fictive players are added at data
                    data.append(gl.simul[n][val])

        ## Transform the list data to a list of list
        # Cut /for_all_players and ,ssffiissffii
        data = data[2:]
        # Set number of item per player
        num_item = 13
        # Cut the long list
        if len(data) % num_item == 0 : # if multiple of num_item
            players_data = chunks(data, num_item) # cut in list of num_item items
        else: # rarely, don't improve
            print("Datas False")

    # players_data ready for other script
    gl.players_data = players_data # a list of list with 13 items

    if len(players_data) > 0:
        # Set level
        level = len(players_data)
        if level == 1 :
            players_data.append(['1.1.1.1', '/ball', 7, 6,  '/bat', 9, 0, '/score', goal[1]["score"], '/name', 'machine', '/rank', 1])
        if level != gl.level:
            # Set level in game.py
            gl.level_change = 1
        gl.level = level

        # where is my ip ?
        where = 0
        if players_data != []:
            for i in range(len(players_data)):
                if players_data[i][0] == gl.local_ip:
                    where = i
        gl.where = where

def chunks(list_to_cut, n):
    # Cut a list in a list of n lists
    return [list_to_cut[i:i+n] for i in range(0, len(list_to_cut), n)]

main()
